"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makePaypalMassPayoutLineNote = exports.paypalMassPayoutLineNoteFullRegexS = exports.extractPayoutBatchKeyFromPaypalMassPayoutLineNote = exports.extractPaypalMassPayoutLineNotePrefixFromPaypalMassPayoutLineNote = exports.payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegexStrict = exports.paypalMassPayoutLineNotePrefixRegexS = exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefix = exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END = exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START = exports.payoutBatchItemCompositeKeyNonLineableIsomorphism = exports.payoutBatchItemCompositeKeyLineableIsomorphism = exports.payoutBatchItemCompositeKeyIsomorphism = exports.shelfCompositeKeyIsomorphism = exports.parserNonLineable = exports.parserLineable = exports.parser = exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = exports.SEPARATOR = void 0;
const parsers_common_1 = require("./parsers.common");
const constants_1 = require("./constants");
const function_1 = require("fp-ts/function");
const O = __importStar(require("fp-ts/Option"));
exports.SEPARATOR = ':';
const payoutBatchItemCompositeKeyIsomorphismFromParseArgs = (strict = true) => (serialized) => {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const [userId, originType, currency, ...rest] = serialized.split(exports.SEPARATOR);
    if (strict && rest.length > 0)
        throw new Error(`invalid serialized PayoutBatchItemCompositeKey: ${serialized}; extra parts: ${rest.join(exports.SEPARATOR)}`);
    return {
        userId,
        originType,
        currency,
    };
};
exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs = payoutBatchItemCompositeKeyIsomorphismFromParseArgs;
exports.parser = parsers_common_1.payoutBatchItemCompositeKeyParser;
exports.parserLineable = parsers_common_1.payoutBatchItemCompositeKeyLineGranularParser;
exports.parserNonLineable = parsers_common_1.payoutBatchItemCompositeKeyNonLineGranularParser;
exports.shelfCompositeKeyIsomorphism = {
    to: ({ userId, originType, currency }) => `${userId}${exports.SEPARATOR}${originType}${exports.SEPARATOR}${currency}`,
    from: (o) => exports.parser.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.payoutBatchItemCompositeKeyIsomorphism = exports.shelfCompositeKeyIsomorphism;
exports.payoutBatchItemCompositeKeyLineableIsomorphism = {
    to: (o) => {
        if (!constants_1.PAYOUT_QUEUE_LINE_GRANULAR_ORIGIN_TYPES.includes(o.originType))
            throw new Error(`invalid origin to present as a line granular key ${o.originType}`);
        return exports.payoutBatchItemCompositeKeyIsomorphism.to(o);
    },
    from: (o) => exports.parserLineable.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.payoutBatchItemCompositeKeyNonLineableIsomorphism = {
    to: (o) => {
        if (!constants_1.PAYOUT_QUEUE_NON_LINE_GRANULAR_ORIGIN_TYPES.includes(o.originType))
            throw new Error(`invalid origin to present as a line granular key ${o.originType}`);
        return exports.payoutBatchItemCompositeKeyIsomorphism.to(o);
    },
    from: (o) => exports.parserNonLineable.parse((0, exports.payoutBatchItemCompositeKeyIsomorphismFromParseArgs)(true)(o)),
};
exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START = '{';
exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END = '}';
const payoutBatchKeyToPaypalMassPayoutLineNotePrefix = (payoutBatchKey) => `${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START}${payoutBatchKey}${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END}`;
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefix = payoutBatchKeyToPaypalMassPayoutLineNotePrefix;
exports.paypalMassPayoutLineNotePrefixRegexS = `${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_START}(.+)${exports.PAYPAL_MASS_PAYOUT_LINE_NOTE_PREFIX_END}`;
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegexStrict = RegExp(`^${exports.paypalMassPayoutLineNotePrefixRegexS}$`);
exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex = RegExp(`${exports.paypalMassPayoutLineNotePrefixRegexS}`);
const payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = (prefix) => {
    const match = prefix.match(exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefixRegex);
    if (!match) {
        throw new Error(`panic! Invalid prefix ${prefix}`);
    }
    return parsers_common_1.payoutBatchKeyParser.parse(match[1]);
};
exports.payoutBatchKeyFromPaypalMassPayoutLineNotePrefix = payoutBatchKeyFromPaypalMassPayoutLineNotePrefix;
// could be notes without it, therefore Option
const extractPaypalMassPayoutLineNotePrefixFromPaypalMassPayoutLineNote = (lineNote) => (0, function_1.pipe)(lineNote.match(`^${exports.paypalMassPayoutLineNotePrefixRegexS}`), O.fromNullable, O.map((m) => m[0]));
exports.extractPaypalMassPayoutLineNotePrefixFromPaypalMassPayoutLineNote = extractPaypalMassPayoutLineNotePrefixFromPaypalMassPayoutLineNote;
const extractPayoutBatchKeyFromPaypalMassPayoutLineNote = (note) => (0, function_1.pipe)(note, exports.extractPaypalMassPayoutLineNotePrefixFromPaypalMassPayoutLineNote, O.map(exports.payoutBatchKeyFromPaypalMassPayoutLineNotePrefix));
exports.extractPayoutBatchKeyFromPaypalMassPayoutLineNote = extractPayoutBatchKeyFromPaypalMassPayoutLineNote;
exports.paypalMassPayoutLineNoteFullRegexS = `^${exports.paypalMassPayoutLineNotePrefixRegexS}(.*)$`;
// has to be a line note; we encode PayoutBatchKey in each of them (note there is necessary redundancy)
const makePaypalMassPayoutLineNote = (key) => (note = '') => {
    // check the note doesn't start with key, runtime
    const existingBatchKey = (0, exports.extractPayoutBatchKeyFromPaypalMassPayoutLineNote)(note);
    if (O.isSome(existingBatchKey)) {
        if (existingBatchKey.value !== key)
            throw new Error(`panic! Note already has a different batch key ${existingBatchKey.value} vs ${key}`);
        return note;
    }
    return `${(0, exports.payoutBatchKeyToPaypalMassPayoutLineNotePrefix)(key)}${note}`;
};
exports.makePaypalMassPayoutLineNote = makePaypalMassPayoutLineNote;
