"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parsers_serialized_1 = require("./parsers.serialized");
const isomorphism_1 = require("./isomorphism");
describe('payout serialized parsers', () => {
    describe('payoutBatchLineableItemCompositeKeySerializedParser', () => {
        it('does the job', () => {
            parsers_serialized_1.payoutBatchLineableItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:stripe:USD');
            expect(() => parsers_serialized_1.payoutBatchLineableItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:paypal:USD')).toThrow('invalid_enum_value');
        });
    });
    describe('payoutBatchLineableItemCompositeKeySerializedParser', () => {
        it('does the job', () => {
            parsers_serialized_1.payoutBatchItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:stripe:USD');
            parsers_serialized_1.payoutBatchItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:paypal:USD');
        });
    });
});
describe('note parser', () => {
    it('parses a note', () => {
        parsers_serialized_1.massPaypalPayoutItemNoteParser.parse('{batchKey} hello');
    });
    it('doesnt parse a note with no prefix', () => {
        expect(parsers_serialized_1.massPaypalPayoutItemNoteParser.safeParse('hello')).toMatchObject({
            success: false,
        });
    });
    it('integrates with its isomorphism', () => {
        const key = 'batchKey';
        const note = 'hello';
        const first = (0, isomorphism_1.makePaypalMassPayoutLineNote)(key)(note);
        parsers_serialized_1.massPaypalPayoutItemNoteParser.parse(first);
    });
});
