import {
  massPaypalPayoutItemNoteParser,
  payoutBatchItemCompositeKeySerializedParser,
  payoutBatchLineableItemCompositeKeySerializedParser,
} from './parsers.serialized';
import { PayoutBatchKey } from './types';
import { makePaypalMassPayoutLineNote } from './isomorphism';

describe('payout serialized parsers', () => {
  describe('payoutBatchLineableItemCompositeKeySerializedParser', () => {
    it('does the job', () => {
      payoutBatchLineableItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:stripe:USD');
      expect(() =>
        payoutBatchLineableItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:paypal:USD')
      ).toThrow('invalid_enum_value');
    });
  });
  describe('payoutBatchLineableItemCompositeKeySerializedParser', () => {
    it('does the job', () => {
      payoutBatchItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:stripe:USD');
      payoutBatchItemCompositeKeySerializedParser.parse('f26rWCTDUiQnbhlCTBDfWFwND8c2:paypal:USD');
    });
  });
});

describe('note parser', () => {
  it('parses a note', () => {
    massPaypalPayoutItemNoteParser.parse('{batchKey} hello');
  });
  it('doesnt parse a note with no prefix', () => {
    expect(massPaypalPayoutItemNoteParser.safeParse('hello')).toMatchObject({
      success: false,
    });
  });
  it('integrates with its isomorphism', () => {
    const key = 'batchKey' as PayoutBatchKey;
    const note = 'hello';
    const first = makePaypalMassPayoutLineNote(key)(note);
    massPaypalPayoutItemNoteParser.parse(first);
  });
});
